Name: gcc-common
Version: 1.4.3
Release: alt1

# Compiler weights
%define weight_33 40
%define weight_32 30
%define weight_296 20
%define weight_295 10

Summary: Common directories, symlinks and selection utility for the GNU Compiler Collection
License: GPL
Group: Development/C
Packager: GCC Development Team <gcc@packages.altlinux.org>

Source0: select-gcc.in
Source1: gccbug.in
Source2: gcc_wrapper.c

Patch: gccbug-alt.patch

PreReq: alternatives >= 0.0.6, coreutils
Requires: rpm >= 0:4.0.4-alt1

Conflicts: cpp2.95 < 1:2.95.3-alt2
Conflicts: cpp2.96 < 0:2.96-alt3, libgcj2.96 < 0:2.96-alt4
Conflicts: cpp3.2 < 0:3.2.1-alt1
Conflicts: cpp < 0:2.96-alt3, cpp = 0:2.96-ipl15mdk, cpp = 0:2.96-ipl16mdk
Conflicts: color-gcc < 0.3-alt2, colorgcc
Conflicts: kaffe < 1.0.6-alt2

# Automatically added by buildreq on Wed Oct 15 2003
BuildRequires: libalternatives-devel

%package -n gcc-c++-common
Summary: Common symlinks for the GNU C++ Compiler
License: GPL
Group: Development/C++
PreReq: %name = %version-%release

%package -n gcc-g77-common
Summary: Common symlinks for the GNU Fortran 77 Compiler
License: GPL
Group: Development/Other
PreReq: %name = %version-%release

%package -n gcc-treelang-common
Summary: Common symlinks for the GNU Treelang Compiler
License: GPL
Group: Development/Other
PreReq: %name = %version-%release

%package -n gcc-java-common
Summary: Common symlinks for the GNU Java Compiler
License: GPL
Group: Development/Java
PreReq: %name = %version-%release

%description
This package contains common symlinks, directories and selection
utility for the GNU Compiler Collection.

%description -n gcc-c++-common
This package contains common symlinks for the GNU C++ Compiler.

%description -n gcc-g77-common
This package contains common symlinks for the GNU Fortran 77 Compiler.

%description -n gcc-treelang-common
This package contains common symlinks for the GNU Treelang Compiler.

%description -n gcc-java-common
This package contains common symlinks for the GNU Java Compiler.

%prep
%setup -cT
%__install -p -m755 %SOURCE0 select-gcc
%__install -p -m755 %SOURCE1 gccbug
%__install -p -m755 %SOURCE2 .

%patch -p1

%build
gcc $RPM_OPT_FLAGS -Werror -D_GNU_SOURCE '-DBINDIR="%_bindir"' \
	'-DTARGET="%_target_platform"' gcc_wrapper.c -o gcc_wrapper
%__subst -p 's|@TARGET@|%_target_platform|g' select-gcc gccbug

%install
%__mkdir_p $RPM_BUILD_ROOT{/lib,%_libdir/gcc-lib/%_target_platform,%_bindir,%_sbindir,%_includedir/c++}
%__install -p -m755 select-gcc $RPM_BUILD_ROOT%_sbindir/
%__install -p -m755 gcc_wrapper $RPM_BUILD_ROOT%_bindir/
%__install -p -m755 gccbug $RPM_BUILD_ROOT%_bindir/%_target_platform-gccbug

%__ln_s ..%_bindir/cpp $RPM_BUILD_ROOT/lib/cpp
%__ln_s gcc $RPM_BUILD_ROOT%_bindir/cc
%__ln_s g++ $RPM_BUILD_ROOT%_bindir/c++
%__ln_s g77 $RPM_BUILD_ROOT%_bindir/f77
%__ln_s %_target_platform-gcc $RPM_BUILD_ROOT%_bindir/%_target_platform-cc
%__ln_s %_target_platform-g++ $RPM_BUILD_ROOT%_bindir/%_target_platform-c++
%__ln_s %_target_platform-g77 $RPM_BUILD_ROOT%_bindir/%_target_platform-f77
%__ln_s %_target_platform-gccbug $RPM_BUILD_ROOT%_bindir/gccbug

for n in cpp g++ g77 gcj gcjh gcov gij grepjar jcf-dump jv-scan protoize rmiregistry tree1 unprotoize; do
	%__ln_s gcc "$RPM_BUILD_ROOT%_bindir/$n"
done

for n in jar rmic; do
	%__ln_s gcc "$RPM_BUILD_ROOT%_bindir/gcj-$n"
done

%__mkdir_p $RPM_BUILD_ROOT%_sysconfdir/%name
cat >$RPM_BUILD_ROOT%_sysconfdir/%name/gcc-3.3<<EOF
<option name="weight" type="number">%weight_33</option>
EOF
cat >$RPM_BUILD_ROOT%_sysconfdir/%name/gcc-3.2<<EOF
<option name="weight" type="number">%weight_32</option>
EOF
cat >$RPM_BUILD_ROOT%_sysconfdir/%name/gcc-2.96<<EOF
<option name="weight" type="number">%weight_296</option>
EOF
cat >$RPM_BUILD_ROOT%_sysconfdir/%name/gcc-2.95<<EOF
<option name="weight" type="number">%weight_295</option>
EOF

%__mkdir_p $RPM_BUILD_ROOT%_altdir
cat >$RPM_BUILD_ROOT%_altdir/%name<<EOF
<group name="candidate">
    <option name="link">%_bindir/gcc</option>
    <option name="real">%_bindir/gcc_wrapper</option>
    <option name="weight" type="number">40</option>
</group>
EOF

%post
%__rm -f /var/lib/rpm/alternatives/{g++,g77,gcj}

if [ -x /usr/sbin/update-alternatives ]; then
	for n in so a; do
		for f in %_libdir/gcc-lib/%_target_platform/*/libstdc++.$n; do
			[ -f "$f" ] || continue
			/usr/sbin/update-alternatives --remove libstdc++.$n "$f" ||:
		done
	done
fi

%register_alternatives %name -- gcc g++ g77 gcj

%triggerpostun -- cpp, cpp2.95 < 1:2.95.3-alt2, cpp2.96 < 0:2.96-alt3, cpp3.2 < 0:3.2.1-alt1, gcc, gcc2.95 < 1:2.95.3-alt2, gcc2.96 < 0:2.96-alt3, gcc3.2 < 0:3.2.1-alt1, gcc-c++, gcc2.95-c++ < 1:2.95.3-alt2, gcc2.96-c++ < 0:2.96-alt3, gcc3.2-c++ < 0:3.2.1-alt1, gcc-g77, gcc2.95-g77 < 1:2.95.3-alt2, gcc2.96-g77 < 0:2.96-alt3, gcc3.2-g77 < 0:3.2.1-alt1, gcc-java, libgcj, gcc2.96-java < 0:2.96-alt3, libgcc2.96 < 0:2.96-alt4, gcc3.2-java < 0:3.2.1-alt1, color-gcc < 0.3-alt2, colorgcc
%register_alternatives %name -- gcc g++ g77 gcj
for n in gccbug; do
	[ -f "%_bindir/$n" -o ! -f "%_bindir/%_target_platform-$n" ] ||
		%__ln_s -f "%_target_platform-$n" "%_bindir/$n"
done
for n in cpp g++ g77 gcj gcjh gcov gij grepjar jcf-dump jv-scan protoize rmiregistry tree1 unprotoize; do
	[ -f "%_bindir/$n" -o ! -f "%_bindir/gcc" ] ||
		%__ln_s -f gcc "%_bindir/$n"
done
for n in jar rmic; do
	[ -f "%_bindir/gcj-$n" -o ! -f "%_bindir/gcc" ] ||
		%__ln_s -f gcc "%_bindir/gcj-$n"
done

%preun
%unregister_alternatives %name

%files
%config %_sysconfdir/%name
%config %_altdir/%name
/lib/*
%_libdir/*
%_bindir/gcc_wrapper
%_bindir/cc
%_bindir/cpp
%_bindir/gccbug
%_bindir/gcov
%_bindir/protoize
%_bindir/unprotoize
%_bindir/%_target_platform-cc
%_bindir/%_target_platform-gccbug
%_sbindir/*

%files -n gcc-c++-common
%_bindir/c++
%_bindir/g++
%_bindir/%_target_platform-c++
%_includedir/c++

%files -n gcc-g77-common
%_bindir/f77
%_bindir/g77
%_bindir/%_target_platform-f77

%files -n gcc-treelang-common
%_bindir/tree1

%files -n gcc-java-common
%_bindir/gcj
%_bindir/gcjh
%_bindir/gcj-jar
%_bindir/gcj-rmic
%_bindir/gij
%_bindir/grepjar
%_bindir/jcf-dump
%_bindir/jv-scan
%_bindir/rmiregistry

%changelog
* Sun Mar 07 2004 Dmitry V. Levin <ldv@altlinux.org> 1.4.3-alt1
- Changed following symlinks to use alternatives like gcc:
  cpp, gcj-*, gcjh, gcov, gij, grepjar, jcf-dump, jv-scan,
  protoize, rmiregistry, unprotoize.
- Updated wrapper to handle gcj-* symlinks.
- select-gcc: added treelang display support.

* Sun Mar 07 2004 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.2-alt1
- Renamed jar and rmic to resolve conflict with j2se-devel
  alternatives (bug #3739).

* Mon Feb 23 2004 Dmitry V. Levin <ldv@altlinux.org> 1.4.1-alt1
- Updated wrapper to handle cc, c++, f77 symlinks (#3728).

* Sun Dec 28 2003 Dmitry V. Levin <ldv@altlinux.org> 1.4-alt1
- Moved symlinks for various frontends to separate subpackages
  (fixes #2733).

* Thu Dec 25 2003 Dmitry V. Levin <ldv@altlinux.org> 1.3-alt3
- Added config for gcc-3.3.

* Thu Oct 16 2003 Dmitry V. Levin <ldv@altlinux.org> 1.3-alt2
- Finalized alternatives transition.

* Thu Oct 16 2003 Stanislav Ievlev <inger@altlinux.ru> 1.3-alt1.3
- port select-gcc to new alternatives

* Wed Oct 15 2003 Stanislav Ievlev <inger@altlinux.ru> 1.3-alt1.2
- second stage: change second alternatives layer

* Wed Oct 15 2003 Stanislav Ievlev <inger@altlinux.ru> 1.3-alt1.1
- first stage: added weight configs for compilers

* Sun Oct 05 2003 Dmitry V. Levin <ldv@altlinux.org> 1.2.3-alt1
- Fixed recent change.

* Sat Oct 04 2003 Dmitry V. Levin <ldv@altlinux.org> 1.2.2-alt1
- Implemented ccache support, see
  http://www.altlinux.ru/pipermail/devel/2003-September/014774.html
  for details.

* Tue Jun 03 2003 Dmitry V. Levin <ldv@altlinux.org> 1.2.1-alt4
- Removed c++filt, it's now provided by binutils.

* Wed May 14 2003 Dmitry V. Levin <ldv@altlinux.org> 1.2.1-alt3
- Workaround rpm bug with deps processing.

* Fri Nov 29 2002 Dmitry V. Levin <ldv@altlinux.org> 1.2.1-alt2
- Corrected dependencies:
  Conflicts: kaffe < 1.0.6-alt2, cpp = 0:2.96-ipl15mdk, cpp = 0:2.96-ipl16mdk

* Fri Nov 29 2002 Dmitry V. Levin <ldv@altlinux.org> 1.2.1-alt1
- Save gccbug via renaming it to %_target_platform-gccbug.
- Corrected dependencies:
  Conflicts: libgcj2.96 < 0:2.96-alt4

* Tue Nov 26 2002 Dmitry V. Levin <ldv@altlinux.org> 1.2-alt1
- Added symlinks:
  %_bindir/%%_target_platform-{cc,c++,f77};
  %_bindir/{cpp,gcov,protoize,unprotoize,c++filt,gcjh,gij,jcf-dump,jv-scan,grepjar,jar,rmic,rmiregistry}.
- Added gcc_wrapper, added alternatives for cpp,gcc,g+,g77,gcj to use it.
- Added gccbug to this package, based on gccbug.in from gcc-3.2.1.
- Changed select-gcc to work with new scheme.

* Tue Sep 10 2002 Dmitry V. Levin <ldv@altlinux.org> 1.1.4-alt1
- select-gcc: fixed libstdc++.so support.

* Sat Aug 31 2002 Dmitry V. Levin <ldv@altlinux.org> 1.1.3-alt1
- Use /bin/readlink.
- Use subst instead of perl for build.

* Fri Aug 23 2002 Dmitry V. Levin <ldv@altlinux.org> 1.1.2-alt1
- Added %_includedir/c++ directory.

* Mon Aug 12 2002 Dmitry V. Levin <ldv@altlinux.org> 1.1.1-alt1
- select-gcc: fixed color* avoidance code.

* Sat Aug 03 2002 Dmitry V. Levin <ldv@altlinux.org> 1.1-alt1
- select-gcc: rewritten to make use of new
  "update-alternatives --config" option.
- select-gcc: avoid changing alternatives pointing to /usr/bin/color*.

* Tue Dec 04 2001 Dmitry V. Levin <ldv@alt-linux.org> 1.0-alt2
- select-gcc: fixed forced selection method.
- Moved symlinks for lib/cpp, %_bindir/cc, %_bindir/c++,
  %_bindir/f77 to this package.

* Thu Nov 22 2001 Dmitry V. Levin <ldv@alt-linux.org> 1.0-alt1
- Initial revision.
